#ifndef H_BALLSELECTOR_H
#define H_BALLSELECTOR_H

#include <GL/glut.h>
#include "Texture.h"
#include "Ball.h"
#include "Vector3d.h"

class CSelectableBall
{
public:
	CVector3d position;
	CVector3d velocity;
};


class CBallSelector
{
public:
	CBallSelector();
	~CBallSelector();

	void Reset();
	void Init();
	void Draw();
	void ProcessClick(int x, int y);
	bool IsDone() { return (done && alpha == 0.0f); }
	void SetBall(CBall* b);

protected:
	void Update();
	void CalculateShadowMatrix();

	float shadow[16];
 	int selected;
	bool done;
	float alpha;

	CBall *ball;

	CSelectableBall balls[3];
	CTexture ballTexture[3];
	CTexture reflectTexture;
	CTexture floorTexture;
	CTexture shadowTexture;
	CTexture titleTexture;

	unsigned int baseBallList;
	unsigned int envBallList;

	GLUquadricObj *sphere;
};

#endif
