#ifndef H_BOUNDINGBOX_H
#define H_BOUNDINGBOX_H

#include "Vector3d.h"
#include "BoundingVolume.h"

class CBoundingBox : public CBoundingVolume
{
public:
	CBoundingBox( const CVector3d& c, const CVector3d& s);
	CBoundingBox( const CVector3d& c, const CVector3d& s, const CVector3d& right, const CVector3d& up);

	const CVector3d& GetSize() const;
	const CVector3d& GetNormal() const;
	const CVector3d& GetRightAxis() const;
	const CVector3d& GetUpAxis() const;
	void SetCenter(const CVector3d& c);
	
	bool CheckSphereCollision(const CVector3d& spherePosition, float radius, CVector3d& intersection, CVector3d& collisionNormal) const;
	bool InFrustum(const CFrustum& frustum) const;

protected:
	CVector3d size;
	CVector3d normal;
	CVector3d rightAxis;
	CVector3d upAxis;
	CVector3d pts[8];
};

#endif
