#ifndef H_BOUNDINGPLANE_H
#define H_BOUNDINGPLANE_H

#include "Vector3d.h"
#include "BoundingVolume.h"

class CBoundingPlane : public CBoundingVolume
{
public:
	CBoundingPlane(const CVector3d& p1, const CVector3d& p2, const CVector3d& p3);

	const CVector3d& GetSize() const;
	const CVector3d& GetNormal() const;
	const CVector3d& GetRightAxis() const;
	const CVector3d& GetUpAxis() const;
	void SetCenter(const CVector3d& c);
	
	bool CheckSphereCollision(const CVector3d& spherePosition, float radius, CVector3d& intersection, CVector3d& collisionNormal) const;
	bool InFrustum(const CFrustum& frustum) const;

protected:
	CVector3d size;
	CVector3d normal;
	CVector3d rightAxis;
	CVector3d upAxis;
	CVector3d pts[4];
};

#endif
