#include "BoundingSphere.h"

CBoundingSphere::CBoundingSphere(const CVector3d& c, float r)
:	CBoundingVolume(c)
{
	radius = r;
}

void CBoundingSphere::SetRadius(float r)
{
	radius = r;
}

float CBoundingSphere::GetRadius() const
{
	return radius;
}

bool CBoundingSphere::InFrustum(const CFrustum& frustum) const
{
	return frustum.CheckSphere(center,radius);
}

bool CBoundingSphere::CheckSphereCollision(const CVector3d& spherePosition, float sphereRadius, CVector3d& intersection, CVector3d& collisionNormal) const
{
	CVector3d dist = spherePosition - center;
	float radii = sphereRadius+radius;

	if (dist.LengthSquared() <= (radii*radii))
	{
		collisionNormal = dist.UnitLength();
		intersection = center + (collisionNormal*radius);
		return true;
	}
	return false;
}
