#ifndef H_BOUNDINGSPHERE_H
#define H_BOUNDINGSPHERE_H

#include "BoundingVolume.h"
#include "Vector3d.h"

class CBoundingSphere : public CBoundingVolume
{
public:
	CBoundingSphere(const CVector3d& c, float r);

	void SetRadius(float r);
	float GetRadius() const;

	bool CheckSphereCollision(const CVector3d& spherePosition, float sphereRadius, CVector3d& intersection, CVector3d& collisionNormal) const;
	bool InFrustum(const CFrustum& frustum) const;

protected:
	float radius;
};

#endif
