#ifndef H_BOUNDINGVOLUME_H
#define H_BOUNDINGVOLUME_H

#include "Vector3d.h"
#include "Frustum.h"

class CBoundingVolume
{
public:
	CBoundingVolume();
	CBoundingVolume(const CVector3d& c);
	
	virtual void SetCenter(const CVector3d& c);
	const CVector3d& GetCenter() const;

	virtual bool CheckSphereCollision(const CVector3d& spherePosition, float radius, CVector3d& intersection, CVector3d& collisionNormal) const = 0;
	virtual bool InFrustum(const CFrustum& frustum) const = 0;

protected:
	CVector3d center;
};

#endif
