#ifndef H_CAMERA_H
#define H_CAMERA_H

#include "Ball.h"
#include "Vector3d.h"

class CCamera
{
public:
	CCamera();

	void LookAt(bool center);
	void Reset();
	void Zoom(float delta);
	void Rotate(float delta);
	void Tilt(float delta);
	float GetRotationDegrees() const;
	void SetDistance(float dist);
	void SetTarget(CBall* ball);
	void SetTilt(float angle);

protected:
	float theta;
	float phi;
	float distance;

	float newHeight;
	float viewHeight;

	CBall* target;
};

#endif
