#ifndef H_CUBE_H
#define H_CUBE_H

#include "Object.h"
#include "Texture.h"
#include "Vector3d.h"

class CCube : public CObject
{
public:
	CCube( const CVector3d& pos, const CVector3d& size, const CTexture* tex , float xTex = 1.0f, float yTex = 1.0f);
	CCube( const CVector3d& p1, const CVector3d& p2, const CVector3d& p3, float depth, const CTexture* tex , float xTex = 1.0f, float yTex = 1.0f);

	void Draw();
	bool IsStatic() { return true; }
	void Update(float elapsed) {}

protected:
	CVector3d rightAxis;
	CVector3d upAxis;
	CVector3d depthAxis;
	CVector3d pts[8];
	const CTexture* texture;
	float s, t;
};

#endif

