#include <GL/glut.h>
#include <stdio.h>
#include "FpsCounter.h"

CFpsCounter::CFpsCounter()
{
}

void CFpsCounter::PrintText(char *string, int x, int y)
{
	glRasterPos2i(x, y);

	while(*string)
		glutBitmapCharacter( GLUT_BITMAP_HELVETICA_12, *string++);
}

long CFpsCounter::GetElapsedTime()
{
	long elapsed;
	// Limit the framerate
	do 
	{
		t2 = glutGet(GLUT_ELAPSED_TIME);
		elapsed = t2 - t1;
	} while (elapsed < 9);

	t1 = t2;

	return elapsed;
}

void CFpsCounter::Display(int windowWidth, int windowHeight)
{
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	frames++;
  curTime = glutGet(GLUT_ELAPSED_TIME);
	long elapsedTime = curTime - startTime;
	glColor3f(1.0, 1.0, 1.0);
	// Only update once per second
	if (elapsedTime >= 1000)
	{
		float framesPerSecond = frames * 1000.0 / elapsedTime ;
		startTime = curTime;
		frames = 0;
		sprintf( fps, "FPS: %.2f", framesPerSecond );
	}

	// Need to set up an orthographic projection
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);	
	glPushMatrix();
	glLoadIdentity();

	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, windowWidth, 0, windowHeight);
	glScalef(1, -1, 1);
	glTranslatef(0, -windowHeight, 0);
	PrintText( fps, 0, 14 );
	glPopMatrix();

	glMatrixMode( GL_MODELVIEW );
	glPopMatrix();

	glPopAttrib();
}
