#include "Mouse.h"

CMouse::CMouse()
{
	leftButtonDown = rightButtonDown = false;
}

void CMouse::LeftButtonDown(int x, int y)
{
	leftButtonDown = true;
	startX = newX = x;
	startY = newY = -y;
}

void CMouse::LeftButtonUp()
{
	leftButtonDown = false;
}

void CMouse::RightButtonDown(int x, int y)
{
	rightButtonDown = true;
	startX = newX = x;
	startY = newY = -y;
}

void CMouse::RightButtonUp()
{
	rightButtonDown = false;
}

void CMouse::TrackMotion(int x, int y)
{
	newY = -y;
	newX = x;
}

int CMouse::DeltaX(bool reset)
{
	int delta = newX-startX;

	if (reset)
		startX = newX;

	return delta;
}

int CMouse::DeltaY(bool reset)
{
	int delta = newY-startY;

	if (reset)
		startY = newY;

	return delta;
}

