#include "MovingFloor.h"

extern const float worldHeight;

CMovingFloor::CMovingFloor(const CVector3d& pos1, const CVector3d& pos2, float x, float z, const CTexture* tex1, const CTexture* tex2)
: CFloor(pos1, x, z, tex1, tex2)
{
	position1 = pos1;
	position2 = pos2;
	count = 0;
}

void CMovingFloor::Update(float elapsed)
{
	float t = sin((++count)*0.005f);
	position = position1 * t + position2 * (1.0f-t);
	bound->SetCenter(position - CVector3d(0,-worldHeight/2.0f,0));
}


