#ifndef H_OBJECT_H
#define H_OBJECT_H

#include "Vector3d.h"
#include "BoundingVolume.h"

class CObject
{
public:
	CObject() {}
	CObject(const CVector3d& pos);
	CObject(const CVector3d& pos, CBoundingVolume* bnd);
	virtual ~CObject();

	virtual void Draw() = 0;
	virtual void Update(float elapsed) = 0;
	virtual bool IsStatic() = 0;
	bool HasBoundingVolume() const { return bound != 0; }
	CBoundingVolume* GetBoundingVolume() { return bound; }
	const CVector3d& GetPosition() { return position; }

protected:
	CVector3d position;
	CBoundingVolume* bound;
};

#endif
