#include "Plane.h"
#include <GL/glut.h>
#include "BoundingPlane.h"

CPlane::CPlane( const CVector3d& p1, const CVector3d& p2, const CVector3d& p3, const CTexture* tex , float xTex, float yTex)
{
	bound = new CBoundingPlane(p1,p2,p3);

	normal = ((CBoundingPlane*)bound)->GetNormal();

	pts[0] = p1;
	pts[1] = p2;
	pts[2] = p3;
	pts[3] = p1 + (p3-p2);
	
	texture = tex;
	s = xTex;
	t = yTex;
}

void CPlane::Draw()
{
	glPushAttrib(GL_ENABLE_BIT);
	glPushMatrix();
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_LIGHTING);
	glDisable(GL_CULL_FACE);
	glColor3f(1.0,1.0,1.0);
	texture->Bind();

	glBegin(GL_QUADS);

	glNormal3fv(normal);
	glTexCoord2f(0,t);   glVertex3fv( pts[0] );
	glTexCoord2f(0,0);  glVertex3fv( pts[1] );
	glTexCoord2f(s,0); glVertex3fv( pts[2] );
	glTexCoord2f(s,t);  glVertex3fv( pts[3] );

	glEnd();
	
	glPopMatrix();
	glPopAttrib();
}


