#include "SkyBox.h"
#include <GL/glut.h>

CSkyBox::CSkyBox()
{
	displayList = 0;
}

CSkyBox::~CSkyBox()
{
	//for (int i = 0; i < 5; i++)
		//textures[i].Delete();
	texture.Delete();

	if (displayList != 0)
		glDeleteLists(displayList,1);
}

void CSkyBox::Init()
{
	/*textures[0].LoadBitmapFile("astro_right.bmp");
	textures[1].LoadBitmapFile("astro_left.bmp");
	textures[2].LoadBitmapFile("astro_down.bmp");
	textures[3].LoadBitmapFile("astro_front.bmp");
	textures[4].LoadBitmapFile("astro_back.bmp");*/
	texture.LoadBitmapFile("astro_front.bmp");
	
	// Create a display list
	displayList = glGenLists(1);
	glNewList(displayList, GL_COMPILE);
	glPushAttrib(GL_ENABLE_BIT);
	glPushMatrix();
	glScalef(200.0f,200.0f,200.0f);
	glEnable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glDepthMask(GL_FALSE);
	glColor4f(1.0f,1.0f,1.0f,1.0f);

	texture.Bind();
	//textures[0].Bind();
	glBegin(GL_TRIANGLE_STRIP);
	glTexCoord2f(0.0f, 1.0f);	glVertex3f(1.0f, 1.0f, -1.0f);
	glTexCoord2f(0.0f, 0.0f); glVertex3f(1.0f, -1.0f, -1.0f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(1.0f, 1.0f, 1.0f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(1.0f, -1.0f, 1.0f);		
	glEnd();

	//textures[1].Bind();
	glBegin(GL_TRIANGLE_STRIP);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, 1.0f, 1.0f);
	glTexCoord2f(0.0f, 0.0f);	glVertex3f(-1.0f, -1.0f, 1.0f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	
	glEnd();

	//textures[2].Bind();
	glBegin(GL_TRIANGLE_STRIP);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
	glTexCoord2f(0.0f, 0.0f);	glVertex3f(-1.0f, -1.0f, 1.0f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(1.0f, -1.0f, -1.0f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(1.0f, -1.0f, 1.0f);
	glEnd();

	//textures[3].Bind();
	glBegin(GL_TRIANGLE_STRIP);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f, 1.0f, -1.0f);
	glTexCoord2f(0.0f, 0.0f);	glVertex3f(-1.0f, -1.0f, -1.0f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(1.0f, 1.0f, -1.0f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(1.0f, -1.0f, -1.0f);
	glEnd();

	//textures[4].Bind();
	glBegin(GL_TRIANGLE_STRIP);
	glTexCoord2f(0.0f, 1.0f); glVertex3f(1.0f, 1.0f, 1.0f);
	glTexCoord2f(0.0f, 0.0f);	glVertex3f(1.0f, -1.0f, 1.0f);
	glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, 1.0f, 1.0f);
	glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, 1.0f);	
	glEnd();
	
	glDepthMask(GL_TRUE);
	glPopMatrix();
	glPopAttrib();
	glEndList();
}

void CSkyBox::Draw()
{
	glCallList(displayList); 	
}
