#include <stdio.h>
#include <GL/glut.h>
#include "Texture.h"

CTexture::CTexture()
{
	textureObject = 0;
}

CTexture::~CTexture()
{
	Delete();
}

void CTexture::Delete()
{
	if (textureObject != 0)
	{
		glDeleteTextures(1,&textureObject);
		textureObject = 0;
	}
}

bool CTexture::LoadBitmapFile(char *filename)
{
	FILE *file;
	unsigned int width, height, size;
	unsigned char *bitmap;
	
	Delete();

	if ( !(file = fopen(filename, "rb")) )
		return false;

	fseek(file, 18, SEEK_CUR);
	fread(&width, 4, 1, file);
  fread(&height, 4, 1, file);
    
  size = width * height * 3;

	if ( !(bitmap = new unsigned char[size]) )
	{
		fclose(file);
		return false;
	}

	fseek(file, 28, SEEK_CUR);
	fread(bitmap, size, 1, file);
	
	unsigned char temp;
	for (unsigned int i = 0; i < size; i += 3)
	{
		temp = bitmap[i];
		bitmap[i] = bitmap[i+2];
		bitmap[i+2] = temp;
	}

	fclose(file);

	glGenTextures(1, &textureObject);
	glBindTexture(GL_TEXTURE_2D, textureObject);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, width, height, GL_RGB, GL_UNSIGNED_BYTE, bitmap);

	delete[] bitmap;	

	return true;
}

bool CTexture::Bind() const
{
	if (textureObject == 0)
		return false;

	glBindTexture(GL_TEXTURE_2D, textureObject);
	return true;
		
}

