#ifndef H_WORLD_H
#define H_WORLD_H

#include "Texture.h"
#include "Object.h"
#include "BoundingVolume.h"
#include "BoundingBox.h"
#include "BoundingPlane.h"
#include "BoundingSphere.h"
#include "Ball.h"
#include "Floor.h"
#include "Frustum.h"
#include <list>

class CBall;

class CWorld
{
public:
	CWorld();
	~CWorld();

	void Init();

	void DrawObjects();
	void DrawFloor();
	void SetBall(CBall* b);
	bool IsBallDone();

protected:
	std::list<CObject*> objects;
	std::list<CFloor*> floors;
	std::list<CBoundingVolume*> bounds;
	CBall* ball;
	CVector3d startPosition;
	CBoundingBox* endPosition;

	CFrustum frustum;
	
	CTexture floorTexture[2];
	CTexture tileTexture[2];
	CTexture woodTexture;
	CTexture barrierTexture;
	CTexture particleTexture;

	unsigned int floorDisplayList;

	friend class CBall;

private:
	void AddFloor( CFloor* floor );
	void AddObject( CObject* obj );
};

#endif
